import math
from math import *
def path_lenght(L_vertex):
    """
    Funzione per il calcolo della lunghezza della traiettoria.
    ARGOMENTI:
    L_vertex= lista contenente le coordinate dei punti: [[x1,y1][x2,y2],...[xn,yn]]
    RETURN:
    lenght = lunghezza della traiettoria
    """
    n_point=len(L_vertex)
    lenght=0.0
    for i in range(n_point-1):
        lenght+=sqrt((L_vertex[i+1][0]-L_vertex[i][0])**2+(L_vertex[i+1][1]-L_vertex[i][1])**2)
    return lenght

def pi_appx(k):
    """
    Funzione per l'approssimazione di pi-greco.
    ARGOMENTI:
    k =number of point
    RETURN:
    appx= approssimazione di pi-greco
    """
    L=[]
    for i in range (k):        
        x=0.5*cos(2*pi*i/k)
        y=0.5*sin(2*pi*i/k)
        if i==0:
            l0=[x,y]
        l=[x,y]
        L.append(l)
    L.append(l0)
    appx=path_lenght(L)
    return appx,L

def error(appx):
    """
    Funzione per il calcolo dell'errore commesso
    """
    return abs(appx-pi)



L=[[1,1],[3,2],[2,3],[1,1]]
l=path_lenght(L)
print "Lunghezza percorsa tra ", L
print "Pari a ", l
print "Approssimazione di pi"

for k in range(2,10):
    n=2**k
    appx,L=pi_appx(n)
    e=error(appx)
    print "Approximation with ", n,  "points", appx
    print "Error equal to ", e


